<?php
/*
 * @package Sj K2 Frontpage
 * @version 3.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2013 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 *
 */
defined('_JEXEC') or die;
?>

<div class="big-item-wrap">
	<div class="big-item-container">
		 <?php 		
		 $img = SjK2FrontPageHelper::getK2Image($item0, $params);					
		 $img = ImageHelper::init($img, $image_config)->src();		
		 
		 if((is_file($img) && file_exists($img)) || SjK2FrontPageHelper::isUrl($img)){?>
			<div class="big-item-image">
				<a href="<?php echo $item0->link; ?>" <?php echo SjK2FrontPageHelper::parseTarget($params->get('target')); ?>>
					<img alt="<?php echo $item0->bigtitle;?>" src="<?php echo $img;?>"/>	
				</a>
			</div>
		<?php }?>
		
		<?php if($item0->bigtitle !=''){ ?>
			<div class="big-item-title">
				<a href="<?php echo $item0->link; ?>" <?php echo SjK2FrontPageHelper::parseTarget($params->get('target')); ?>>			
					<?php echo $item0->bigtitle;?>
				</a>
			</div>
		<?php }?>
		
		<?php if( (int)$params->get('big_item_datetime_display') ){ ?>
			<div class="big-item-datetime">
				<?php echo JHtml::date($item0->publish_up, 'd F Y'); ?>
			</div>
		<?php }?>

		<?php if($item0->Introtext != '') { ?>
			<div class="big-item-description">
				<?php echo $item0->Introtext; ?>
			</div>
		<?php }
				
		// show tags
	
		if($params->get('big_item_tag_display') == 1 && $item0->tags != '') {	?>
			<div class="big-item-tags">
				<?php foreach ($item0->tags as $tag): ?>
				<span class="tag-<?php echo $tag->id; ?>">
					<a class="label label-info" href="<?php echo $tag->link; ?>" title="<?php echo $tag->name; ?>" target="_blank"><?php echo $tag->name; ?></a>
				</span>
				<?php endforeach; ?>
			 </div>					
		<?php }	?>
				
				
		<?php if( (int)$params->get('item_readmore_display') && ($params->get('item_readmore_text') !='')  ){ ?>
			<div class="big-item-readmore">
				<a href="<?php echo $item0->link; ?>" <?php echo SjK2FrontPageHelper::parseTarget($params->get('target')); ?>>
				<?php echo $params->get('item_readmore_text'); ?>
				</a>		
			</div>
		<?php }?>
	</div>
</div><!-- display big item end -->

<div class="small-item-list">
	<div class="small-items-container">
	<?php $postion_index = 0;
	$postion_class = '';
	foreach($items as $key => $item){
		$postion_index++;
		if ($postion_index==1){
			$postion_class = 'item-first';
		} else if ($postion_index==count($items)){
			$postion_class = 'item-last';
		} else {
			$postion_class = '';
		} ?>
		<div class="small-item-wrap <?php echo $postion_class; ?>">
			<?php
			$img = SjK2FrontPageHelper::getK2Image($item, $params);
			$small_img = ImageHelper::init($img,$small_image_config)->src();
			
			if((is_file($small_img) && file_exists($small_img)) || SjK2FrontPageHelper::isUrl($small_img)){?>			
				<div class="small-item-image">
					<a href="<?php echo $item->link; ?>" <?php echo SjK2FrontPageHelper::parseTarget($params->get('target')); ?>>
						<img alt="<?php echo $item->smalltitle;?>" src="<?php echo $small_img;?>"/>					
					</a>
				</div>
			<?php }?>
			
			<div class="small-item-content">
				<?php if($item->smalltitle !='' ){ ?>
					<div class="small-item-title">
						<a href="<?php echo $item->link; ?>" <?php echo SjK2FrontPageHelper::parseTarget($params->get('target')); ?> >
							<?php echo $item->smalltitle ;?>
						</a>
					</div>
				<?php }?>

				<?php if( (int)$params->get('small_item_datetime_display', 1) ){ ?>
					<div class="small-item-datetime">
						<?php echo JHtml::date($item->publish_up, 'd F Y'); ?>
					</div>
				<?php }?>
						
				
				
				<?php if($item->SmallIntrotext != '') { ?>
					<div class="small-item-description">
						<?php echo $item->SmallIntrotext; ?>
					</div>
				<?php }
		
				if($params->get('small_item_tag_display') == 1 && $item->tags != '') {	?>
					<div class="small-item-tags">
						<?php foreach ($item->tags as $tag):?>
						<span class="tag-<?php echo $tag->id; ?>">
							<a class="label label-info" href="<?php echo $tag->link; ?>" title="<?php echo $tag->name; ?>" target="_blank"><?php echo $tag->name; ?></a>
						</span>
						<?php endforeach; ?>
					 </div>					
				<?php }	?>	
			</div>
		</div>
	<?php }?>
	</div>        
</div>